package figure;

import java.io.*;

public class Main
{
  final static char SQUARE = '1';
  final static char RECT = '2';
  final static char PUSH = '3';
  final static char POP = '4';
  final static char PRINTALL = '5';
  final static char EXIT = '6';

  final static char ROTATE = 'r';
  final static char APOTHEM = 'a';

  static FigureStack m_stack = new FigureStack();
  static Figure m_figure = null;

  public static String read()
      throws IOException
  {
    String s = "";
    int c;
    while ((c = System.in.read()) != '\n')
      s += (char) c;
    return s;
  }

  public static void printMenu()
  {
    System.out.println("----------------------------------------------------");
    System.out.println("current figure:");
    if (m_figure == null)
      System.out.println("NULL");
    else
      System.out.println(m_figure.toString());
    System.out.println("The stack contains " + m_stack.size() + " figures");
    System.out.println("" + SQUARE + ") INSERT SQUARE");
    System.out.println("" + RECT + ") INSERT RECTANGLE");
    System.out.println("" + PUSH + ") PUSH");
    System.out.println("" + POP + ") POP");
    System.out.println("" + PRINTALL + ") PRINTALL");
    if (m_figure != null && m_figure instanceof RegPoly)
    {
      System.out.println("" + APOTHEM + ") GET APOTHEM");
      System.out.println("" + ROTATE + ") ROTATE");
    }
    System.out.println("" + EXIT + ") EXIT");
  }

  public static void main(String[] args)
  {
    char choice = 0;
    do
    {
      printMenu();
      try
      {
        choice = Character.toLowerCase(read().charAt(0));
        if (choice == RECT)
          m_figure = Rectangle.read();
        else
        if (choice == SQUARE)
          m_figure = Square.read();
        else
        if (choice == PUSH)
        {
          m_stack.push(m_figure);
          m_figure = null;
        }
        else
        if (choice == POP)
          m_figure = m_stack.pop();
        else
        if (choice == PRINTALL)
          m_stack.printAll(System.out);
        else
        /*------- for reg poly only ------*/
        if (choice == APOTHEM)
          System.out.println("Apothem = " + ((RegPoly)m_figure).getApothem());
        else
        if (choice == ROTATE)
        {
          System.out.print("insert angle (degrees): ");
          double ang = Double.parseDouble(read());
          ((RegPoly)m_figure).rotate(ang);
        }
      }
      catch (IOException ex)
      {
        ex.printStackTrace();
      }
    }
    while (choice != EXIT);
  }
}
