package figure;

import java.io.*;

public class Point2D
{
  private double m_x, m_y;

  public Point2D()
  {
    this(0,0);
  }

  public Point2D(double x, double y)
  {
    m_x = x; m_y = y;
  }

  public double getX()
  {
    return m_x;
  }

  public double getY()
  {
    return m_y;
  }

  public static Point2D add(Point2D p1, Point2D p2)
  {
    return new Point2D(p1.getX() + p2.getX(), p1.getY() + p2.getY());
  }

  public static Point2D rotate(Point2D p, double degree)
  {
    degree *= Math.PI / 180;
    double x = p.getX();
    double y = p.getY();
    double x1 = x * Math.cos(degree) - y * Math.sin(degree);
    double y1 = y * Math.cos(degree) + x * Math.sin(degree);
    return new Point2D(x1, y1);
  }

  public static double dist(Point2D p1, Point2D p2)
  {
    return Math.sqrt(Math.pow(p1.getX() - p2.getX(), 2) +
                     Math.pow(p1.getY() - p2.getY(), 2));
  }

  public double dist(Point2D p)
  {
    return dist(this, p);
  }

  public String toString()
  {
    return "<" + m_x + ":" + m_y + ">";
  }

  public static Point2D read()
      throws IOException
  {
    System.out.print("X: ");
    double x = Double.parseDouble(Main.read());
    System.out.print("Y: ");
    double y = Double.parseDouble(Main.read());
    return new Point2D(x,y);
  }
}
